#!/usr/bin/perl
require 5.005;
require 'log.cfg';

getdata();
$font='sans-serif,MS UI Gothic,MS Gothic,Osaka';
if(defined &${command}){&${command}();exit()}
$qr_path="$uroot/qr";
$qr_url="$urooturl/qr";
$qr_string=~s/\s+/\n/g;
$qr_error=$qr_size==1?'H':$qr_size>2?'M':'Q';
$data_cnt=0;
if($qr_app_n>1&&$qr_app_n<=16&&$qr_app_m<=16&&$qr_app_m>0){
  $data_value[0]=3;
  $data_bits[0]=4;
  $data_value[1]=$qr_app_m-1;
  $data_bits[1]=4;
  $data_value[2]=$qr_app_n-1;
  $data_bits[2]=4;
  $orgdata_length=length($qr_orgdata);
  if($orgdata_length>1){
    $i=$qr_parity=0;
    while($i<$orgdata_length){
      $qr_parity=($qr_parity ^ ord(substr($qr_orgdata,$i,1)));
      $i++;
    }
  }
  $data_value[3]=$qr_parity;
  $data_bits[3]=8;
  $data_cnt=4;
}
$data_bits[$data_cnt]=4;
if($qr_string=~/[^0-9]/){
  if($qr_string=~/[^0-9A-Z \$\*\%\+\-\.\/\:]/){
    @codeword_num_plus=(0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8);
    $data_value[$data_cnt]=4;
    $data_cnt++;
  	$data_bits[$data_cnt]=8;
    $data_value[$data_cnt]=$data_length;
    $codeword_num_counter_value=$data_cnt;
  	$i=0;
    $data_cnt++;
	  while ($i<$data_length){
	    $data_value[$data_cnt]=ord(substr($qr_string,$i,1));
	    $data_bits[$data_cnt]=8;
	    $data_cnt++;
	    $i++;
    }
  }else{
    @codeword_num_plus=(0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,4,4,4,4,4,4,4,4,4,4,4,4,4,4);
    $data_value[$data_cnt]=2;
    $data_cnt++;
  	$data_value[$data_cnt]=$data_length;
  	$data_bits[$data_cnt]=9;
    $codeword_num_counter_value=$data_cnt;
    %alphanumeric_character_hash=("0",0,"1",1,"2",2,"3",3,"4",4,"5",5,"6",6,"7",7,"8",8,"9",9,"A",10,"B",11,"C",12,"D",13,"E",14,"F",15,"G",16,"H",17,"I",18,"J",19,"K",20,"L",21,"M",22,"N",23,"O",24,"P",25,"Q",26,"R",27,"S",28,"T",29,"U",30,"V",31,"W",32,"X",33,"Y",34,"Z",35," ",36,"\$",37,"\%",38,"\*",39,"\+",40,"\-",41,"\.",42,"\/",43,"\:",44);
  	$i=0;
    $data_cnt++;
  	while ($i<$data_length){
	    if(($i%2)==0){
	    	$data_value[$data_cnt]=$alphanumeric_character_hash{substr($qr_string,$i,1)};
  	  	$data_bits[$data_cnt]=6;
	    }else{
    		$data_value[$data_cnt]=$data_value[$data_cnt]*45+$alphanumeric_character_hash{substr($qr_string,$i,1)};
    		$data_bits[$data_cnt]=11;
    		$data_cnt++;
	    }$i++;
  	}
  }
}else{
  @codeword_num_plus=(0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,4,4,4,4,4,4,4,4,4,4,4,4,4,4);
  $data_value[$data_cnt]=1;
  $data_cnt++;
  $data_value[$data_cnt]=$data_length;
  $data_bits[$data_cnt]=10;
  $codeword_num_counter_value=$data_cnt;
  $i=0;
  $data_cnt++;
  while($i<$data_length){
    if(($i%3)==0){
      $data_value[$data_cnt]=substr($qr_string,$i,1);
      $data_bits[$data_cnt]=4;
    }else{
	    $data_value[$data_cnt]=$data_value[$data_cnt]*10+substr($qr_string,$i,1);
	    if(($i%3)==1){
    		$data_bits[$data_cnt]=7;
	    }else{
    		$data_bits[$data_cnt]=10;
    		$data_cnt++;
	    }
    }$i++;
  }
}
if($data_bits[$data_cnt]>0){$data_cnt++}
$i=$total_data_bits=0;
while($i<$data_cnt){
  $total_data_bits+=$data_bits[$i];
  $i++;
}
%ecc_character_hash=("L",1,"l",1,"M",0,"m",0,"Q",3,"q",3,"H",2,"h",2);
$ecc=$ecc_character_hash{$qr_error};
unless($ecc){$ecc=0}
@max_data_bits_array=(0,128,224,352,512,688,864,992,1232,1456,1728,2032,2320,2672,2920,3320,3624,4056,4504,5016,5352,5712,6256,6880,7312,8000,8496,9024,9544,10136,10984,11640,12328,13048,13800,14496,15312,15936,16816,17728,18672,152,272,440,640,864,1088,1248,1552,1856,2192,2592,2960,3424,3688,4184,4712,5176,5768,6360,6888,7456,8048,8752,9392,10208,10960,11744,12248,13048,13880,14744,15640,16568,17528,18448,19472,20528,21616,22496,23648,72,128,208,288,368,480,528,688,800,976,1120,1264,1440,1576,1784,2024,2264,2504,2728,3080,3248,3536,3712,4112,4304,4768,5024,5288,5608,5960,6344,6760,7208,7688,7888,8432,8768,9136,9776,10208,104,176,272,384,496,608,704,880,1056,1232,1440,1648,1952,2088,2360,2600,2936,3176,3560,3880,4096,4544,4912,5312,5744,6032,6464,6968,7288,7880,8264,8920,9368,9848,10288,10832,11408,12016,12656,13328);
if($qr_ver=~/[^0-9]/){$qr_ver=""}
if($qr_ver){$max_data_bits=$max_data_bits_array[$qr_ver+40*$ecc]}
else{$i=1+40*$ecc;$j=$i+39;$qr_ver=1;
  while($i<=$j){
    if(($max_data_bits_array[$i])>=$total_data_bits+$codeword_num_plus[$qr_ver]){
      $max_data_bits=$max_data_bits_array[$i];
      last;
    }$i++;$qr_ver++;
  }
}
if($qr_ver>40){$qr_ver=40}
$total_data_bits+=$codeword_num_plus[$qr_ver];
$data_bits[$codeword_num_counter_value]+=$codeword_num_plus[$qr_ver];
@max_codewords_array=(0,26,44,70,100,134,172,196,242,292,346,404,466,532,581,655,733,815,901,991,1085,1156,1258,1364,1474,1588,1706,1828,1921,2051,2185,2323,2465,2611,2761,2876,3034,3196,3362,3532,3706);
$max_codewords=$max_codewords_array[$qr_ver];
$max_side=17+($qr_ver<<2);
@matrix_remain_bit=(0,0,7,7,7,7,7,0,0,0,0,0,0,0,3,3,3,3,3,3,3,4,4,4,4,4,4,4,3,3,3,3,3,3,3,0,0,0,0,0,0);
$byte_num=$matrix_remain_bit[$qr_ver]+($max_codewords<<3);
$filename=$qr_path."/qrv".$qr_ver."_".$ecc.".tpl";
open (IN,$filename);binmode(IN);
sysread(IN,$matx,$byte_num);
sysread(IN,$maty,$byte_num);
sysread(IN,$masks,$byte_num);
sysread(IN,$fi_x,15);
sysread(IN,$fi_y,15);
sysread(IN,$rs_ecc_codewords_chr,1);
$rs_ecc_codewords=ord($rs_ecc_codewords_chr);
sysread(IN,$rso,128);close(IN);
@matrix_x_array=unpack("C*",$matx);
@matrix_y_array=unpack("C*",$maty);
@mask_array=unpack("C*",$masks);
@rs_block_order=unpack("C*",$rso);
@format_inf_x2=unpack("C*",$fi_x);
@format_inf_y2=unpack("C*",$fi_y);
@format_inf_x1=(0,1,2,3,4,5,7,8,8,8,8,8,8,8,8);
@format_inf_y1=(8,8,8,8,8,8,8,8,7,5,4,3,2,1,0);
$max_data_codewords=($max_data_bits>>3);
$filename=$qr_path."/rsc".$rs_ecc_codewords.".tpl";
open(IN2,$filename);
binmode(IN2);
$i=0;
while($i<256){
  sysread(IN2,$rs_cal_table_array[$i],$rs_ecc_codewords);
  $i++;
}close IN2;
if($total_data_bits<=$max_data_bits-4){
  $data_value[$data_cnt]=0;
  $data_bits[$data_cnt]=4;
}else{
  if($total_data_bits<$max_data_bits){
  	$data_value[$data_cnt]=0;
    $data_bits[$data_cnt]=$max_data_bits-$total_data_bits;
  }else{
    if($total_data_bits>$max_data_bits){
	    print qq|content-type: text/html\n
QRcode : Overflow error
|;exit();
    }
  }
}
$i=$codewords_counter=$codewords[0]=0;
$remaining_bits=8;
while($i<=$data_cnt){
  $buffer=$data_value[$i];
  $buffer_bits=$data_bits[$i];
  $flag=1;
  while($flag){
    if($remaining_bits>$buffer_bits){
      $codewords[$codewords_counter]=(($codewords[$codewords_counter]<<$buffer_bits)|$buffer);
      $remaining_bits-=$buffer_bits;
      $flag=0;
    }else{
      $buffer_bits-=$remaining_bits;
      $codewords[$codewords_counter]=(($codewords[$codewords_counter]<<$remaining_bits)|($buffer>>$buffer_bits));
      if($buffer_bits==0){$flag=0}else{$buffer=($buffer&((1<<$buffer_bits)-1));$flag=1}
      $codewords_counter++;
      if($codewords_counter<$max_data_codewords-1){$codewords[$codewords_counter]=0}
      $remaining_bits=8;
    }
  }$i++;
}
if($remaining_bits!=8){
  $codewords[$codewords_counter]=$codewords[$codewords_counter]<<$remaining_bits;
}else{$codewords_counter--}
if($codewords_counter<$max_data_codewords-1){
  $flag=1;
  while($codewords_counter<$max_data_codewords-1){
    $codewords_counter++;
    if($flag==1){$codewords[$codewords_counter]=236}
    else{$codewords[$codewords_counter]=17}
    $flag=$flag*(-1);
  }
}
$i=$j=$rs_block_num=0;
@rs_temp=();
while($i<$max_data_codewords){
  $rs_temp[$rs_block_num].=chr($codewords[$i]);
  $j++;
  if($j>=$rs_block_order[$rs_block_num]-$rs_ecc_codewords){
  	$j=0;
  	$rs_block_num++;
  }$i++;
}
$rs_block_num=0;
$rs_block_order_num=$#rs_block_order+1;
while($rs_block_num<=$rs_block_order_num){
  $rs_codewords=$rs_block_order[$rs_block_num];
  $rs_codewords=~s/\n//g;
  $rs_data_codewords=$rs_codewords-$rs_ecc_codewords;
  $rstemp=$rs_temp[$rs_block_num].(chr(0)x$rs_ecc_codewords);
  $j=$rs_data_codewords;
  while($j>0){
    $first=ord(substr($rstemp,0,1));
    if($first!=0){
      $left_chr=substr($rstemp,1);
      $cal=$rs_cal_table_array[$first];
      $rstemp=$left_chr^$cal;
    }else{$rstemp=substr($rstemp,1)}
    $j--;
  }
  push(@codewords,unpack("C*",$rstemp));
  $rs_block_num++;
}
$i=0;
while($i<$max_side){
  $j=0;
  while($j<$max_side){
    $matrix_cont[$j][$i]=0;
    $j++;
  }$i++;
}
$i=0;
while($i<$max_codewords){
  $codeword_i=$codewords[$i];
  $j=7;
  while($j>=0){
    $codeword_bits_num=($i<<3)+$j;
    $matrix_cont[$matrix_x_array[$codeword_bits_num]][$matrix_y_array[$codeword_bits_num]]=((255*($codeword_i&1))^$mask_array[$codeword_bits_num]);
    $codeword_i=$codeword_i>>1;
    $j--;
  }$i++;
}
$matrix_remain=$matrix_remain_bit[$qr_ver];
while($matrix_remain){
  $remain_bit_temp=$matrix_remain+($max_codewords<<3);
  $matrix_cont[$matrix_x_array[$remain_bit_temp]][$matrix_y_array[$remain_bit_temp]]=(255^$mask_array[$remain_bit_temp]);
  $matrix_remain--;
}
$k=$min_demerit_score=0;
$hor_master=$ver_master="";
while($k<$max_side){
  $l=0;
  while($l<$max_side){
    $hor_master=$hor_master.chr($matrix_cont[$l][$k]);
    $ver_master=$ver_master.chr($matrix_cont[$k][$l]);
    $l++;
  }$k++;
}
$i=0;
$all_matrix=$max_side*$max_side;
while($i<8){
  $demerit_n1=0;
  @ptn_temp=();
  $bit=1<<$i;
  $bit_r=(~$bit)&255;
  $bit_mask=chr($bit)x$all_matrix;
  $hor=$hor_master&$bit_mask;
  $ver=$ver_master&$bit_mask;
  $ver_and=((chr(170)x$max_side).$ver)&($ver.(chr(170)x$max_side));
  $ver_or=((chr(170)x$max_side).$ver)|($ver.(chr(170)x$max_side));
  $hor=~$hor;
  $ver=~$ver;
  $ver_and=~$ver_and;
  $ver_or=~$ver_or;
  substr($ver_and,$all_matrix,0)=chr(170);
  substr($ver_or,$all_matrix,0)=chr(170);
  $k=$max_side-1;
  while($k){
    substr($hor,$k*$max_side,0)=chr(170);
    substr($ver,$k*$max_side,0)=chr(170);
    substr($ver_and,$k*$max_side,0)=chr(170);
    substr($ver_or,$k*$max_side,0)=chr(170);
    $k--;
  }
  $hor=$hor.chr(170).$ver;
  $n1_search=(chr(255)x5)."+|".(chr($bit_r)x5)."+";
  $n2_search1=chr($bit_r).chr($bit_r)."+";
  $n2_search2=chr(255).chr(255)."+";
  $n3_search=chr($bit_r).chr(255).chr($bit_r).chr($bit_r).chr($bit_r).chr(255).chr($bit_r);
  $n4_search=chr($bit_r);
  $hor_temp=$hor;
  $demerit_n3=($hor_temp=~s/$n3_search//g)*40;
  $demerit_n4=int(abs(((100*(($ver=~s/$n4_search//g)/($byte_num)))-50)/5))*10;
  $match_before_num=length($ver_and)+length($ver_or);
  $match_num=($ver_and=~s/$n2_search1//g)+($ver_or=~s/$n2_search2//g);
  $match_after_num=length($ver_and)+length($ver_or);
  $demerit_n2=($match_before_num-$match_after_num-$match_num)*3;
  $match_before_num=length($hor);
  $match_num=($hor=~s/$n1_search//g);
  $match_after_num=length($hor);
  $demerit_n1=$match_before_num-$match_after_num-($match_num<<1);
  $demerit_score=$demerit_n1+$demerit_n2+$demerit_n3+$demerit_n4;
  if($demerit_score<=$min_demerit_score||$i==0){$mask_num=$i;
  $min_demerit_score=$demerit_score}$i++;
}
$mask_cont=1<<$mask_num;
$format_inf_value=(($ecc<<3)|$mask_num);
@format_inf_array=("101010000010010","101000100100101","101111001111100","101101101001011","100010111111001","100000011001110","100111110010111","100101010100000","111011111000100","111001011110011","111110110101010","111100010011101","110011000101111","110001100011000","110110001000001","110100101110110","001011010001001","001001110111110","001110011100111","001100111010000","000011101100010","000001001010101","000110100001100","000100000111011","011010101011111","011000001101000","011111100110001","011101000000110","010010010110100","010000110000011","010111011011010","010101111101101");
$i=0;
while($i<15){
  $cont=substr($format_inf_array[$format_inf_value],$i,1);
  $matrix_cont[$format_inf_x1[$i]][$format_inf_y1[$i]]=$cont*255;
  $matrix_cont[$format_inf_x2[$i]][$format_inf_y2[$i]]=$cont*255;
  $i++;
}
unless($chk&&$ext ne'html'){
  @dot=('b','d');
	open(IN,"$qr_path/qrvfr${qr_ver}.tpl");@cc=<IN>;chomp @cc;close IN;
	print qq|content-type:text/html\n
<html><body bgcolor="#ffffff" style="margin:10 0 0 10">\n
|;for($i=0;$i<$max_side;$i++){
	  for($j=0;$j<$max_side;$j++){
	    $ccx=substr($cc[$i],$j,1);
	    print qq{<img src="$qr_url/$dot[(($ccx)||(($matrix_cont[$j][$i]&$mask_cont)>0))].png" width="$qr_size" height="$qr_size">};
	  }print "<br>\n";
	}print '</body></html>';
}else{
  eval 'use GD;';
	$qr_imgsize=$qr_size*($max_side+8);
	$qr_path=$qr_path."/qrv".$qr_ver.".png";
	$output_image=GD::Image->new($qr_imgsize,$qr_imgsize);
	$base_image=GD::Image->newFromPng($qr_path);
	$color[1]=$base_image->colorAllocate(0,0,0);
	$color[0]=$base_image->colorAllocate(255,255,255);
	$mxe=4+$max_side;
	for($i=4,$ii=0;$i<$mxe;$i++,$ii++){
	  for($j=4,$jj=0;$j<$mxe;$j++,$jj++){
	    if($matrix_cont[$ii][$jj]&$mask_cont){$base_image->setPixel($i,$j,$color[1])}
	  }
	}
	$output_image->copyResized($base_image,0,0,0,0,$qr_imgsize,$qr_imgsize,$max_side+8,$max_side+8);
	$fname="QR.$ext";$fname=~s/jpeg/jpg/;##$ext=~s/png/x-png/;
	print qq|content-type: image/$ext
content-disposition: filename="$fname"\n
|;binmode STDOUT;
	print $output_image->$ext;
}
sub makethumb{
  %num=('O',0,'P',1,'Q',2,'R',3,'S',4,'T',5,'U',6,'V',7,'W',8,'X',9,);
  foreach(keys %num){$wid=~s/$_/$num{$_}/}
  ($h,$body)=split(/\r?\n\r?\n/,$file,2);
  eval 'use GD;';
  if($h=~m!filename="(.+\.(gif|png|jpe?g))".*content-type:\s?"?image/([-\w]+)"?!is){$fname=$1;$type=lc($3);$fname=~s!^.*[/\\:]!!;$type=~s/x-//;$type=~s/p(?=jp)//;
  if($type=~/gif/){$orgimage=newFromGifData GD::Image($body)}
  if($type=~/jpe?g/){$orgimage=newFromJpegData GD::Image($body)}
  if($type=~/png/){$orgimage=newFromPngData GD::Image($body)}
  @bound=$orgimage->getBounds();
  $wid||=$bound[0];
  if($bound[0]!=$wid||$type ne $ext){
    $hei=int($bound[1]/($bound[0]/$wid));
    $thumbnail=new GD::Image($wid,$hei);
    $thumbnail->copyResized($orgimage,0,0,0,0,$wid,$hei,$bound[0],$bound[1]);
		$body=$thumbnail->$ext;
  }else{$wid=$bound[0];$hei=$bound[1]}
  if($save){if($save=~s{(.+)[/\\]}{}){$savedir=$1}else{$savedir=$uroot}
  $fname="$save.$ext";$fname=~s/\.jpeg$/\.jpg/;
	open(IMG,">$savedir/$fname");binmode IMG;
	print IMG $body;close IMG;
}else{$fname=~s/\.\w+$/\.$ext/;$fname=~s/\.jpeg$/\.jpg/}
$ext=~s/jpeg/pjpeg/;$ext=~s/png/x-png/;
print qq|content-type: image/$ext
content-disposition: filename="$fname"\n
|;binmode STDOUT;print $body;exit()}
else{print "content-type: text/html\n
<ul><br>f[^擾ł܂B"}}
sub rainbou{
$fhex=cgi_conv::z2h($fhex);$fhex=lc($fhex);
$size=cgi_conv::z2h($size);
$bg=cgi_conv::z2h($bg);
$fhex='df' unless($fhex=~/[0-9a-f][0-9a-f]/i);
$size=20 unless($size);
@txt=split(/\x0D\x0A|\x0D|\x0A/,$text);
foreach $txt(@txt){
$leter.=rainbo($fhex,$txt,$size);
$leter.='<br>'}
$bg||='#0000ff';
$leter=~s{<font color="[^"]+"> </font>}{}g;
($source=$leter)=~s/</&lt;/g;$source=~s/>/&gt;/g;$source=~s/"/&quot;/g;
if($size>5){$siz=qq(span style=&quot;font-size:${size}px;background-color:$bg&quot;&gt;$source&lt;/span)}
else{$siz=qq(font size=&quot;$size&quot;&gt;$source&lt;/font);$size+=12}
print qq{content-type: text/html; charset=$char\n
<html><head>
<meta http-equiv="pragma" content="no-cache">
<meta http-equiv="cache-control" content="no-cache">
<meta http-equiv="expires" content="0">
<meta name="content-language" content="ja">
<meta http-equiv="content-type" content="text/html; charset=$char">
</head><body bgcolor="#efefef" style="margin:0 0 0 0">
<table width="336" cellpadding="6"><td bgcolor="$bg"><div style="font-size:${size}px;line-height:120%;$font">$leter</td></table>
<!-- tr bgcolor="#f5f5dc"><td><div style="font-size:12px;line-height:110%;$font">$source </td></tr -->
<table width="336" cellpadding="6"><form name="s"><td align="center"><input type="button" value="R[hҏWʂɓ]" onclick="textin('\\n&lt;$siz&gt;','')"></td></form></table>
<script type="text/javascript">function textin(s,e){parent.parent.editf.enclose(s,e)}</script>
</body></html>}}
sub rainbo{
  my($r,$text,$size)=@_;
  my($bf,$af,$leter);
  $text=~s/^((<[^\W]+>)+)//;$bf=$1;
  $text=~s/((<\/[^\W]+>)+)$//;$af=$1;
  $text=~s/<[^\W]+>//g;
  $text=jcode::euc($text);
  $text=join("\0",$text=~m/([\x8E\xA1-\xFE][\xA1-\xFE]|\x8F[\xA1-\xFE][\xA1-\xFE]|.|\n)/g);
  $len=@text=split(/\0/,$text);
  $color_d1=255;
  $mul=$color_d1/$len;
  @hx=hexarray(16);
  $i=-1;
  foreach $str(@text){$i++;
    $color_d1=255*sin($i/($len/3));
    $color_h1=tohex($color_d1);
    $color_d2=$mul*$i;
    $color_h2=tohex($color_d2);
    $leter.=qq{<font color="\#$r$color_h1$color_h2">$str</font>};
  }
  $leter=jcode::sjis($leter);
  $leter=qq{$bf$leter$af}
}
sub hexarray{
  my$n=shift;
  for($i=1;$i<=$n;$i++){if($i==11){$j='a'}if($i<11){$hx[$i]=$i-1}else{$hx[$i]=$j;$j++}}
  return @hx;
}
sub tohex{
  my$x=shift;
  $high=$x/16;
  $high=int(substr($high,0,2));
  $low=$x-$high*16;
  $low=int(substr($low,0,2));
  return "$hx[$high+1]$hx[$low+1]";
}
sub getdata{
($script,$uroot,$urooturl,$libpath,$dbpath,$lockdir,$emoji,$default,$timeoffset,$charcode,$htaccess,$ipcheck,$myipnl,$crypt,$char,$scrdir,$scrdirurl,$scrabsurl,$scrabsdir,$work,$pfile)=cfg::init();
open(P,$pfile);$p=<P>;close P;chomp $p;
if($ENV{'HTTP_COOKIE'}=~/wEbAn=([^:]+):([^;\s]+)/){$chk=$1}
unless($p&&$chk&&$chk eq $p){print qq|content-type: text/html\n
<ul><br>삷錠܂B
|;exit()}
require 'cgi-conv.pl';
if($ENV{'CONTENT_LENGTH'}||$ENV{'QUERY_STRING'}){
%FORM=cgi_conv::getdata($charcode,$libpath);
foreach(keys %FORM){(${$_}=$FORM{$_})=~s/\x81\x40/  /g}}
$qr_string=~s/^\s+|\s+$//g;
$data_length=length($qr_string);
if(!$command&&$data_length<=0||$command&&$file!~/.+\.(gif|jpe?g|png)/&&!$text){
print qq|content-type: text/html\n
<ul><br>f[^܂B
|;exit()}open(FLG,">$lockdir/admin.flg");close FLG}
1;
__END__
2007.05.05 v3.11
